%
% Attempts to extract a character from a region
%
function character = doOcr(img, region)
    bbox = region.BoundingBox;
    width = bbox(3);
    height = bbox(4);
    aspect = width / height;
    euler = bweuler(bwmorph(region.Image,'thin',Inf));

    ocrResult = ocr(bwmorph(region.Image, 'thin',3), ...
                    'Language','dlang/tessdata/dlang.traineddata', ...
                    'TextLayout','Character');
    % Hack of the century - please forgive me
    if size(ocrResult.Text,1) == 0 || ocrResult.WordConfidences == 0
        if aspect < 0.4
            character = '1';
        elseif euler == -1
            character = 'B';
        else
            error("Unknown character");
        end
    elseif ocrResult.Text == '1' && width > 30 && ocrResult.WordConfidences < 0.5
        character = 'B';
    elseif ((aspect < 0.5 && euler > 0) || aspect < 0.4) && ocrResult.WordConfidences < 0.7
        character = '1';
    elseif ocrResult.Text == ' ' && euler == -1
        character = 'B';
    else
        character = ocrResult.Text;
    end
end