%
% Tests all example automata images.
%
% Output folders:
%   spec - for program specifications
%   prog - for synthesized programs
%   ann  - for annotated images
%
function gentest()
    automata = ["a1", "a2", "a3", "odd_one", "one_of_each", "stutter", "mult_3", "ascii_digits", "five_ones", "syllables"];

    folderIfNotExist("spec");
    folderIfNotExist("prog");
    folderIfNotExist("ann");

    for ix=1:size(automata,2)
        img = imread("ex/" + automata(ix) + ".jpg");
        ann = run(img, "spec/" + automata(ix) + "_spec.sl", "prog/" + automata(ix) + "_prog.sl");
        imwrite(ann, "ann/" + automata(ix) + "_ann.png");
    end
end

%
% Creates the given folder if it doesn't exist
%
function folderIfNotExist(name)
    if ~exist(name, 'dir')
        mkdir(name);
    end
end