%
% Synthesizes an automaton from the given features.
% If specFile is provided, saves the generated specification to that filename.
%
% NOTE: z3 is required to be on the path. If not, edit the system call
% below to point to wherever z3 is installed on your machine.
%
% Get z3: https://github.com/Z3Prover/z3
function results = synthesize(states, transitions, labels, posEx, negEx, specFile)

    for extras=0:5
        if exist('specFile','var')
            fname = specFile;
        else
            fname = tempname;
        end
        exportDefinition(fname, states, transitions, labels, posEx, negEx,extras);
        [status, results] = system("z3 """ + fname + """");
        if status == 0
            disp("In file: " + fname);
            disp("Synthesis Result (with " + extras + " extra states):");
            disp(results);
            return;
        else
            disp("In file " + fname);
            disp(results);
        end
        delete(fname);
    end
end